from stdlib.string cimport Str
from stdlib.socket cimport getaddrinfo, socket, AF_UNSPEC, SOCK_STREAM, AI_PASSIVE, MSG_WAITALL, SHUT_WR, SHUT_RD

from libc.stdio cimport puts, printf


def main():
    cdef const char * arg
    cdef Str recv

    loop = True

    while loop:
        b = input("Message to send:\n").encode()
        arg = b
        with nogil:
            a = getaddrinfo(NULL, Str("3490"), AF_UNSPEC, SOCK_STREAM, 0, AI_PASSIVE)[0]

            s = socket(a.family, a.socktype, a.protocol)

            s.connect(a.sockaddr)

            msg = Str(arg)
            s.sendall(msg)

            s.shutdown(SHUT_WR)

            recv = s.recvall()
            printf('received: %s\n\n', Str.to_c_str(recv))

            s.close()

            if msg != recv:
                puts('sent and received are different')

            if msg == Str('quit'):
                loop = False

main()
